//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "advsearch.h"
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmAdvSearch *frmAdvSearch;
//---------------------------------------------------------------------------
__fastcall TfrmAdvSearch::TfrmAdvSearch(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmAdvSearch::BitBtn2Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------



void TfrmAdvSearch::AddDisGroup()
{
        TADOQuery *qty = new TADOQuery(NULL);
        TObject *obj;
        int i;
        for(i=0;i<=cbForum->Items->Count-1;i++)
        {
          obj = cbForum->Items->Objects[i];
          if(obj)
            delete obj;
        }
        cbForum->Clear();
        AddItem("Qװ",0);
        qty->Connection = frmMain->ADOConnection1;
        qty->SQL->Text = "SELECT * FROM FORUM_FORUM,FORUM_CATEGORY WHERE FORUM_FORUM.CAT_ID=FORUM_CATEGORY.CAT_ID AND CAT_PID=0 ORDER BY CAT_ORDER,CAT_NAME,F_SUBJECT";
        qty->Open();
        while(!qty->Eof)
        {
            AddItem(qty->FieldByName("F_SUBJECT")->AsString,qty->FieldByName("FORUM_ID")->AsInteger);
            qty->Next();
        }
        delete qty;
}
//---------------------------------------------------------------------------

void TfrmAdvSearch::AddItem(AnsiString text, int id)
{
        int *obj = new int;
        *obj = id;
        cbForum->Items->AddObject(text,(TObject *)obj);
}
//---------------------------------------------------------------------------

void __fastcall TfrmAdvSearch::FormCreate(TObject *Sender)
{
        AddDisGroup();
        cbForum->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TfrmAdvSearch::FormShow(TObject *Sender)
{
        cbForum->ItemIndex = 0;
        cbDate->ItemIndex = 0;
        cbField->ItemIndex = 0;
        cbMeb->Text = "";
        Edit1->Text = "";
        SType->ItemIndex = 1;
        CheckBox1->Checked = true;
        CheckBox2->Checked = true;
        CheckBox3->Checked = true;
        CheckBox4->Checked = false;
        CheckBox5->Checked = true;
        CheckBox6->Checked = false;
        CheckBox7->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmAdvSearch::BitBtn1Click(TObject *Sender)
{
  AnsiString ssql,swhere,s,ss,smatch,subwhere,sop;
  AnsiString catlist,msg;
  int forumid,i;
  TDateTime today;
  TADOQuery *qty;
  TReplaceFlags fFlags;
  fFlags << rfReplaceAll;
  char buf[1024],*ptr;

  ss = Trim(Edit1->Text);
  smatch = "";
  //Memo1->Clear();

  ssql = "select distinct FORUM_TOPICS.TOPIC_ID,FORUM_TOPICS.FORUM_ID,T_DATE,T_SUBJECT,T_CODESYSTEM,T_AUTHOR,T_REPLIES,";
  ssql += "T_LAST_POST,T_GOOD from FORUM_TOPICS";
  //Memo1->Lines->Add(ss);
  //Memo1->Lines->Add(ssql);
  if (ss.Length() <= 1)
  {
    return;
  }
  else
  {
    if (SType->ItemIndex == 0)
      smatch = "(T_SUBJECT='"+ss+"')";
    else
    {
      if(SType->ItemIndex==1)
        sop = " and ";
      else
        sop = " or  ";
      strcpy(buf,ss.c_str());
      ptr = strtok(buf," ");
      smatch += "T_SUBJECT like '%"+AnsiString(ptr)+"%'";
      while((ptr = strtok(NULL," ")))
      {
        smatch += sop+"T_SUBJECT like '%"+AnsiString(ptr)+"%'";
      }
      smatch = "("+smatch+")";
    }
    //Memo1->Lines->Add(smatch);

    if(cbField->ItemIndex == 0)
    { //search all field, need FORUM_REPLY
      subwhere = StringReplace(smatch,"T_SUBJECT","R_MESSAGE",fFlags);
      smatch = " ("+smatch+" or "+StringReplace(smatch,"T_SUBJECT","T_MESSAGE",fFlags)+")";
      if (Trim(cbMeb->Text).Length() == 0)
        swhere = "and ("+smatch+" or "+subwhere+")";
    }
    else
    {
      if (Trim(cbMeb->Text).Length() == 0)
        swhere = "and " + smatch;
    }
  }

  if(Trim(cbMeb->Text).Length()>0)
  {  //need search member
    qty = new TADOQuery(NULL);
    qty->Connection = frmMain->ADOConnection1;
    qty->SQL->Text = "select MEMBER_ID from FORUM_MEMBERS where M_NAME='"+Trim(cbMeb->Text)+"'";
    qty->Open();

    if(smatch.Length() > 0)
      smatch = " and "+smatch;
    if(subwhere.Length() > 0)
      subwhere = " and "+subwhere;
    if(qty->RecordCount > 0)
      s = qty->FieldByName("MEMBER_ID")->AsString;
    else
      s = "";

    if(s.Length() > 0)
    {
      smatch = "T_AUTHOR="+ s + smatch;
      if(cbField->ItemIndex != 0)
        swhere = " and ("+smatch+")";
      else
      {    //search all field, need FORUM_REPLY
        subwhere = " R_AUTHOR="+s+subwhere;
        swhere =" and (("+smatch+") or ("+subwhere+"))";
      }
    }
    else
    {
      msg = "䤣|"+Trim(cbMeb->Text);
      Application->MessageBox(msg.c_str(),"ĵi",MB_OK);
      delete qty;
      return;
    }
    delete qty;
  }
 // Memo1->Lines->Add(swhere);

  today = Date();
  switch(cbDate->ItemIndex)
  {
    case 0:
        break;
    case 1:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",today-1));
        break;
    case 2:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",today-3));
        break;
    case 3:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",today-7));
        break;
    case 4:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",today-14));
        break;
    case 5:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",IncMonth(today,-1)));
        break;
    case 6:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",IncMonth(today,-2)));
        break;
    case 7:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",IncMonth(today,-3)));
        break;
    case 8:
        swhere += " and T_DATE >="+QuotedStr(FormatDateTime("yyyymmdd",IncMonth(today,-12)));
        break;
    default:
        ;
  }
  /// Memo1->Lines->Add(swhere);
  if (cbForum->ItemIndex > 0)
  {  //Qװ
    forumid = (int)(cbForum->Items->Objects[cbForum->ItemIndex]);
    swhere += " and FORUM_TOPICS.FORUM_ID="+AnsiString(forumid);
  }
  else
  { //Qװ, ݤ
    catlist = ",";
    qty = new TADOQuery(NULL);
    qty->Connection = frmMain->ADOConnection1;

    for (i=0;i<=GroupBox1->ControlCount - 1;i++ )
    {//for each check box
      if (((TCheckBox *)(GroupBox1->Controls[i]))->Checked)
      {
        qty->Close();
        qty->SQL->Text = "select CAT_ID from FORUM_CATEGORY where CAT_KIND="+AnsiString(((TCheckBox *)(GroupBox1->Controls[i]))->Tag);
        qty->Open();
        while(!qty->Eof)
        {
          if (catlist.Pos(","+qty->FieldByName("CAT_ID")->AsString+",")==0)
            catlist += qty->FieldByName("CAT_ID")->AsString+",";
          qty->Next();
        }
      }
    }
    delete qty;
    if (catlist.Length() > 2)
    {
      catlist = catlist.SubString(2,catlist.Length()-2);
    }
    else
    {
      Application->MessageBox("пܤΰQװ","ĵi",MB_OK);
      return;
    }
    swhere += " and FORUM_TOPICS.CAT_ID in ("+catlist+")";
  }
  swhere = "1=1 " + swhere;
  //Memo1->Lines->Add(swhere);
  if(subwhere.Length() > 0)
    ssql += ",FORUM_REPLY,FORUM_TOPICS left join FORUM_REPLY on FORUM_TOPICS.TOPIC_ID = FORUM_REPLY.TOPIC_ID";

  if (CheckBox6->Checked)
    swhere += " AND T_GOOD='Y'";
  if (CheckBox7->Checked)
    swhere += " AND T_FIELNAME='Y'";
  //Memo1->Lines->Add(swhere);

  ssql += " where "+swhere+" ORDER BY T_LAST_POST DESC ";
 // Memo1->Lines->Add(ssql);

  frmMain->TopicList->Close();
  frmMain->TopicList->SQL->Text = ssql;
  frmMain->TopicList->Open();

  if(frmMain->TopicList->IsEmpty())
  {
      Application->MessageBox("䤣","G",MB_OK);
      return;
  }
  frmMain->UpdateSD();
  frmMain->SD->Row = 1;
  Close();

}
//---------------------------------------------------------------------------

