//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reg.h"

AnsiString Reg::GetRegitryValue(AnsiString Name)
{
  AnsiString S;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    Registry->RootKey = HKEY_CURRENT_USER;
    // False because we do not want to create it if it doesn't exist
    Registry->OpenKey(Root,true);
    S = Registry->ReadString(Name);
  }
  __finally
  {
    delete Registry;
  }
  return S;

}
//---------------------------------------------------------------------------
void Reg::SetRegitryValue(AnsiString Name,AnsiString Value)
{
  TRegistry *Reg = new TRegistry;
  try
  {
    Reg->RootKey = HKEY_CURRENT_USER;
    if (Reg->OpenKey(Root, true))
    {
      Reg->WriteString(Name,Value);
      Reg->CloseKey();
    }
  }
  __finally
  {
    delete Reg;

  }
}
//---------------------------------------------------------------------------
int Reg::GetRegitryInteger(AnsiString Name)
{
  int S;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    Registry->RootKey = HKEY_CURRENT_USER;
    // False because we do not want to create it if it doesn't exist
    Registry->OpenKey(Root,true);
    S = Registry->ReadInteger(Name);
  }
  __finally
  {
    delete Registry;
  }
  return S;

}
//---------------------------------------------------------------------------
#pragma package(smart_init)
