//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "setup.h"
#include "reg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSetup *frmSetup;
//---------------------------------------------------------------------------
__fastcall TfrmSetup::TfrmSetup(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmSetup::UseIEClick(TObject *Sender)
{
        if(!UseIE->Checked && Proxy->Checked)
        {
            ProxyServer->Enabled = true;
            ProxyPort->Enabled = true;
        }
        else
        {
            ProxyServer->Enabled = false;
            ProxyPort->Enabled = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmSetup::BitBtn2Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------


/*
[HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings]
"ProxyEnable"=dword:00000001
"ProxyServer"=":"
*/
void __fastcall TfrmSetup::BitBtn1Click(TObject *Sender)
{
        Reg reg;
        reg.Root = "\\Software\\BCB_KTOP_Reader";
        reg.SetRegitryValue("ProxyServer",ProxyServer->Text);
        reg.SetRegitryValue("ProxyPort",ProxyPort->Text);
        reg.SetRegitryValue("AutoUpdate",AutoUpdate->Checked?"1":"0");
        reg.SetRegitryValue("UseIE",UseIE->Checked?"1":"0");
        reg.SetRegitryValue("Proxy",Proxy->Checked?"1":"0");
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmSetup::FormCreate(TObject *Sender)
{
        Reg reg;
        reg.Root = "\\Software\\BCB_KTOP_Reader";
        ProxyServer->Text = reg.GetRegitryValue("ProxyServer");
        ProxyPort->Text = reg.GetRegitryValue("ProxyPort").Length() > 0 ? reg.GetRegitryValue("ProxyPort") : AnsiString("8080");
        AutoUpdate->Checked = reg.GetRegitryValue("AutoUpdate") == "1" ? true : false;
        UseIE->Checked = reg.GetRegitryValue("UseIE") == "1" ? true : false;
        Proxy->Checked = reg.GetRegitryValue("Proxy") == "1" ? true : false;
        ProxyClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmSetup::ProxyClick(TObject *Sender)
{
        if(Proxy->Checked)
        {
            UseIE->Enabled = true;
        }
        else
        {
            UseIE->Enabled = false;
        }
        UseIEClick(Sender);
}
//---------------------------------------------------------------------------

