//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "SHDocVw_OCX.h"
#include <OleCtrls.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Grids.hpp>
#include <ImgList.hpp>
#include <HTTPApp.hpp>
#include <HTTPProd.hpp>
#include <ADODB.hpp>
#include <DB.hpp>
#include <DBGrids.hpp>
#include <jpeg.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdHTTP.hpp>
#include <IdTCPClient.hpp>
#include <IdTCPConnection.hpp>
#include <NMHttp.hpp>
#include <Psock.hpp>
#include "IdCompressionIntercept.hpp"
#include <IdIntercept.hpp>
//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
        TToolBar *ToolBar1;
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel2;
        TSplitter *Splitter1;
        TPanel *Panel3;
        TPanel *Panel4;
        TSplitter *Splitter2;
        TTreeView *tv;
        TImageList *ImageList1;
        TToolButton *ToolButton2;
        TPageProducer *PageProducer1;
        TADOQuery *Topic;
        TADOQuery *Reply;
        TADOConnection *ADOConnection1;
        TADOQuery *TopicList;
        TStringGrid *SD;
        TTimer *Timer1;
        TToolButton *ToolButton1;
        TEdit *Search;
        TImage *Image1;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TToolButton *ToolButton6;
        TToolButton *ToolButton7;
        TToolButton *ToolButton8;
        TToolButton *ToolButton9;
        TToolButton *ToolButton10;
        TIdHTTP *IdHTTP1;
        TNMHTTP *NMHTTP1;
        TADOConnection *ADOConnection2;
        TCppWebBrowser *CppWebBrowser1;
        void __fastcall PageProducer1HTMLTag(TObject *Sender, TTag Tag,
          const AnsiString TagString, TStrings *TagParams,
          AnsiString &ReplaceText);
        void __fastcall tvChange(TObject *Sender, TTreeNode *Node);
        void __fastcall SDSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall CppWebBrowser1BeforeNavigate2(TObject *Sender,
          LPDISPATCH pDisp, Variant *URL, Variant *Flags,
          Variant *TargetFrameName, Variant *PostData, Variant *Headers,
          VARIANT_BOOL *Cancel);
        void __fastcall CppWebBrowser1NavigateError(TObject *Sender,
          LPDISPATCH pDisp, Variant *URL, Variant *Frame,
          Variant *StatusCode, VARIANT_BOOL *Cancel);
        void __fastcall ToolButton3Click(TObject *Sender);
        void __fastcall ToolButton9Click(TObject *Sender);
        void __fastcall NMHTTP1PacketRecvd(TObject *Sender);
        void __fastcall NMHTTP1Success(CmdType Cmd);
        void __fastcall NMHTTP1InvalidHost(bool &Handled);
        void __fastcall NMHTTP1Failure(CmdType Cmd);
        void __fastcall ToolButton7Click(TObject *Sender);
        void __fastcall Image1Click(TObject *Sender);
        void __fastcall ToolButton1Click(TObject *Sender);
        void __fastcall SearchKeyPress(TObject *Sender, char &Key);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ToolButton5Click(TObject *Sender);
private:
        TStringList *Meb,*MebID;
        int SDSelect;
        int FileDown,FileDowning;
        AnsiString DBFile;
        AnsiString cvtDatestr(AnsiString s);
        AnsiString ModifyMessageStr(AnsiString ws, AnsiString CodeSystem );
        void SubTree(TTreeNode * pnd, AnsiString cat_id);
        void TopTree();
        void ShowTopic(AnsiString id);
        AnsiString cvtDateTimestr(AnsiString s);
        void Init();
        void DeCompressFile(AnsiString Src, AnsiString Des);
        void ImportMDB(AnsiString mdbfn);
        void CopyTable(AnsiString tbname, AnsiString keyname);
        void UpdateProxy();	// User declarations
public:		// User declarations
        __fastcall TfrmMain(TComponent* Owner);
        void UpdateSD();
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
